# Interface methods for submodule: BSplineBaseTransform
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate
from ._proxies import TransformProxy as _TransformProxy


# Interface methods for class: BSplineBaseTransform
class BSplineBaseTransformProxy(_TransformProxy):
	def GetNameOfClass(self):
		""""""
		...

	def Clone(self):
		""""""
		...

	def SetParameters(self, parameters) -> None:
		""""""
		...

	def SetFixedParameters(self, parameters) -> None:
		""""""
		...

	def SetParametersByValue(self, parameters) -> None:
		""""""
		...

	def SetIdentity(self) -> None:
		""""""
		...

	def GetParameters(self):
		""""""
		...

	def GetFixedParameters(self):
		""""""
		...

	def SetCoefficientImages(self, images) -> None:
		""""""
		...

	def GetCoefficientImages(self):
		""""""
		...

	def UpdateTransformParameters(self, update: Sequence[float], factor: float = 1) -> None:
		""""""
		...

	@overload
	def TransformPoint(self, point: Sequence[float]) -> Sequence[float]:
		""""""
		...

	@overload
	def TransformPoint(self, inputPoint: Sequence[float], outputPoint: Sequence[float], weights: Sequence[float], indices: Sequence[int], inside: bool) -> None:
		""""""
		...

	@overload
	def TransformVector(self, arg0: Sequence[float]) -> Sequence[float]:
		""""""
		...

	@overload
	def TransformVector(self, arg0: vnl_vector_fixed) -> vnl_vector_fixed:
		""""""
		...

	def TransformCovariantVector(self, arg0: Sequence[float]) -> Sequence[float]:
		""""""
		...

	def ComputeJacobianFromBSplineWeightsWithRespectToPosition(self, arg0: Sequence[float], arg1: Sequence[float], arg2: Sequence[int]) -> None:
		""""""
		...

	def ComputeJacobianWithRespectToParameters(self, arg0: Sequence[float], arg1) -> None:
		""""""
		...

	def ComputeJacobianWithRespectToPosition(self, arg0: Sequence[float], arg1: vnl_matrix_fixed) -> None:
		""""""
		...

	def GetNumberOfParameters(self) -> int:
		""""""
		...

	def GetNumberOfParametersPerDimension(self) -> int:
		""""""
		...

	def GetTransformCategory(self):
		""""""
		...

	def GetNumberOfAffectedWeights(self) -> int:
		""""""
		...

	def GetNumberOfLocalParameters(self) -> int:
		""""""
		...

